#!/bin/sh
# $Id: 0_getit.sh 25 2016-08-06 15:53:04Z dettus $

echo " 
       -----         -----         
      /     \\       /     \\       /
     /       \\     /       \\     /
-----         -----         -----
     \\       /     \\       /     \\
      \\     /       \\     /       \\
       -----         ----- detLFS  -
      /     \\       /     \\       /
     /       \\     /       \\     /
-----         -----         -----
http://www.dettus.net/detLFS/detLFS_0.04.gar.gz

 This script is downloading the packages prior to anything else.
 It is also unpacking them in the Sources folder, and renamining
 them. This makes upgrading the system easier, because the Version
 numbers have to be changed in here, nowhere else.

 The kernel is being downloaded from the Raspberry Github, since
 this is the platform I plan on running everything on.
" ; date 




export DOWNLOADSDIR=`pwd`/Downloads
export SOURCESDIR=`pwd`/Sources
mkdir -p $DOWNLOADSDIR
mkdir -p $SOURCESDIR


echo ">>> downloading busybox" ; date 
(
	wget --directory-prefix=$DOWNLOADSDIR -c https://busybox.net/downloads/busybox-1.25.0.tar.bz2
	cd $SOURCESDIR ; tar xfj $DOWNLOADSDIR/busybox-1.25.0.tar.bz2 ; mv busybox-1.25.0 busybox
)
echo ">>> downloading binutils" ; date 
(
	wget --directory-prefix=$DOWNLOADSDIR -c ftp://ftp.gnu.org/gnu/binutils/binutils-2.27.tar.gz
	cd $SOURCESDIR ; tar xfz $DOWNLOADSDIR/binutils-2.27.tar.gz ; mv binutils-2.27 binutils
)
echo ">>> downloading glibc" ; date 
(
	wget --directory-prefix=$DOWNLOADSDIR -c ftp://ftp.gnu.org/gnu/glibc/glibc-2.24.tar.xz
	cd $SOURCESDIR ; tar xfJ $DOWNLOADSDIR/glibc-2.24.tar.xz ; mv glibc-2.24 glibc
)
echo ">>> downloading gcc" ; date 
(
	wget --directory-prefix=$DOWNLOADSDIR -c ftp://ftp.gnu.org/gnu/gmp/gmp-6.1.1.tar.xz
	wget --directory-prefix=$DOWNLOADSDIR -c ftp://ftp.gnu.org/gnu/mpfr/mpfr-3.1.4.tar.xz
	wget --directory-prefix=$DOWNLOADSDIR -c ftp://ftp.gnu.org/gnu/mpc/mpc-1.0.3.tar.gz
	wget --directory-prefix=$DOWNLOADSDIR -c ftp://ftp.gnu.org/gnu/gcc/gcc-6.1.0/gcc-6.1.0.tar.gz
	cd $SOURCESDIR ; tar xfz $DOWNLOADSDIR/gcc-6.1.0.tar.gz ; mv gcc-6.1.0 gcc
	cd gcc
	tar xfJ $DOWNLOADSDIR/gmp-6.1.1.tar.xz ; mv gmp-6.1.1 gmp
	tar xfJ $DOWNLOADSDIR/mpfr-3.1.4.tar.xz ; mv mpfr-3.1.4 mpfr
	tar xfz $DOWNLOADSDIR/mpc-1.0.3.tar.gz ; mv mpc-1.0.3 mpc

)
echo ">>> downloading binutils" ; date 
(
	wget --directory-prefix=$DOWNLOADSDIR -c ftp://ftp.gnu.org/pub/gnu/binutils/binutils-2.26.1.tar.gz
	cd $SOURCESDIR ; tar xfz $DOWNLOADSDIR/binutils-2.26.1.tar.gz ; mv binutils-2.26.1 binutils
)
echo ">>> downloading make" ; date 
(
	wget --directory-prefix=Downloads/ -c ftp://ftp.gnu.org/gnu/make/make-4.2.1.tar.gz
	cd $SOURCESDIR ; tar xfz $DOWNLOADSDIR/make-4.2.1.tar.gz ; mv make-4.2.1 make
)


echo ">>> downloading the kernel, specifically for the Raspberry Pi" ; date 
(
	cd $DOWNLOADSDIR
	git clone https://github.com/raspberrypi/linux
	git reset --hard git 4eda74f2dfcc8875482575c79471bde6766de3ad
	rm -rf linux/.git
	cp -r $DOWNLOADSDIR/linux $SOURCESDIR/
)
echo ">>> downloading Raspberry Pi's bootloader" ; date 
(
	wget -O $DOWNLOADSDIR/bootcode.bin  "https://raw.githubusercontent.com/raspberrypi/firmware/master/boot/bootcode.bin" 
	wget -O $DOWNLOADSDIR/start.elf "https://raw.githubusercontent.com/raspberrypi/firmware/master/boot/start.elf" 
)

echo ">>> done" ; date

