#!/bin/sh
# $Id: 3c_morepackages.sh 23 2016-08-01 20:54:03Z dettus $
echo " 
       -----         -----         
      /     \\       /     \\       /
     /       \\     /       \\     /
-----         -----         -----
     \\       /     \\       /     \\
      \\     /       \\     /       \\
       -----         ----- detLFS  -
      /     \\       /     \\       /
     /       \\     /       \\     /
-----         -----         -----
http://www.dettus.net/detLFS/detLFS_0.04.gar.gz

 The purpose of this script is to provide an example of how to 
 compile your own packages.

 Hopefully, the previous scripts are finished at this point.
" ; date

export DETLFSROOT=`pwd`
export TOOLSDIR=`pwd`/Tools
export BUILDDIR=`pwd`/Build
export SOURCESDIR=`pwd`/Sources
export DOWNLOADSDIR=`pwd`/Downloads
export DESTINATIONDIR=`pwd`/Destination


export PATH=$TOOLSDIR/bin:$PATH
export CROSS_COMPILE=$TOOLSDIR/bin/arm-linux-gnueabihf-
export DESTDIR=$DESTINATIONDIR


echo ">>> ncurses" ; date
(
	wget --directory-prefix=$DOWNLOADSDIR -c ftp://ftp.gnu.org/gnu/ncurses/ncurses-6.0.tar.gz
	cd $SOURCESDIR ; tar xfz $DOWNLOADSDIR/ncurses-6.0.tar.gz ; mv ncurses-6.0 ncurses
# this patch is necessary to build ncurses 6.0 with gcc-5.4.0. stupid ass GNU project... all falling apart and shit...
	(
		echo "--- ncurses/ncurses/base/MKlib_gen.sh.orig	2015-08-07 02:48:24.000000000 +0200
+++ ncurses/ncurses/base/MKlib_gen.sh	2016-07-28 08:34:56.249302048 +0200
@@ -491,11 +491,21 @@
 	-e 's/gen_\$//' \\
 	-e 's/  / /g' >>\$TMP
 
+cat >\$ED1 <<EOF
+s/  / /g
+s/^ //
+s/ $//
+s/P_NCURSES_BOOL/NCURSES_BOOL/g
+EOF
+
+# A patch discussed here:
+#       https://gcc.gnu.org/ml/gcc-patches/2014-06/msg02185.html
+# introduces spurious #line markers.  Work around that by ignoring the system's
+# attempt to define 'bool' and using our own symbol here.
+sed -e 's/bool/P_NCURSES_BOOL/g' \$TMP > \$ED2
+cat \$ED2 >\$TMP
 \$preprocessor \$TMP 2>/dev/null \\
-| sed \\
-	-e 's/  / /g' \\
-	-e 's/^ //' \\
-	-e 's/_Bool/NCURSES_BOOL/g' \\
+| sed -f \$ED1 \\
 | \$AWK -f \$AW2 \\
 | sed -f \$ED3 \\
 | sed \\" | patch -p0
	)
	cd $BUILDDIR
	mkdir ncurses1 ; cd ncurses1
	$SOURCESDIR/ncurses/configure --prefix=/usr --target=arm-linux-gnueabihf --host=arm-linux-gnueabihf --without-sysmouse   --disable-ext-mouse  --enable-widec --with-shared --with-cxx-shared

	make -j 8 && make install
)


echo ">> building alsa-firmware"
(
	wget --directory-prefix=$DOWNLOADSDIR -c ftp://ftp.alsa-project.org/pub/firmware/alsa-firmware-1.0.29.tar.bz2
	cd $SOURCESDIR ; tar xvfj $DOWNLOADSDIR/alsa-firmware-1.0.29.tar.bz2 ; mv alsa-firmware-1.0.29/ alsa-firmware/

	cd $BUILDDIR
	mkdir alsa-firmware1 ; cd alsa-firmware1
	cp -r  $SOURCESDIR/alsa-firmware .	# alsa firmware does not build like the others. 
	cd alsa-firmware
	./configure --prefix=/usr --target=arm-linux-gnueabihf 
	make	 -j  8
	make install

)

echo ">>> building alsa-libs"
(
	wget --directory-prefix=$DOWNLOADSDIR -c ftp://ftp.alsa-project.org/pub/lib/alsa-lib-1.1.1.tar.bz2
	cd $SOURCESDIR ; tar xvfj $DOWNLOADSDIR/alsa-lib-1.1.1.tar.bz2 ; mv alsa-lib-1.1.1 alsa-lib
	cd $BUILDDIR
	mkdir alsa-lib1 ; cd alsa-lib1
	$SOURCESDIR/alsa-lib/configure --target=arm-linux-gnueabihf --prefix=/usr
	make -j 8
	make install
)



du -sh $TOOLSDIR
du -sh $BUILDDIR
du -sh $DESTINATIONDIR

echo ">>> done" ; date

